"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMakeStyles = void 0;
const Object_fromEntries_1 = require("./tools/Object.fromEntries");
const objectKeys_1 = require("./tools/objectKeys");
const cssAndCx_1 = require("./cssAndCx");
/**
 * @see {@link https://github.com/garronej/tss-react}
 */
function createMakeStyles(params) {
    const { useTheme } = params;
    /** returns useStyle. */
    function makeStyles() {
        return function (getCssObjectOrCssObject) {
            const getCssObject = typeof getCssObjectOrCssObject === "function"
                ? getCssObjectOrCssObject
                : () => getCssObjectOrCssObject;
            function useStyles(params) {
                const theme = useTheme();
                const { cx, css } = (0, cssAndCx_1.useCssAndCx)();
                let count = 0;
                function createRef() {
                    return `tss-react-ref_${count++}`;
                }
                const cssObject = getCssObject(theme, params, createRef);
                const classes = (0, Object_fromEntries_1.fromEntries)((0, objectKeys_1.objectKeys)(cssObject).map(key => [
                    key,
                    css(cssObject[key]),
                ]));
                return {
                    classes,
                    theme,
                    css,
                    cx,
                };
            }
            return useStyles;
        };
    }
    function useStyles() {
        const theme = useTheme();
        const { css, cx } = (0, cssAndCx_1.useCssAndCx)();
        return { theme, css, cx };
    }
    return { makeStyles, useStyles };
}
exports.createMakeStyles = createMakeStyles;
